// (w) by Oliver Goetze 2011-11
// for xxzLinearChain_stiffness.ccm  (JS2011: LC ???)
  
#define _USR_PARAMETER_ "xxzLC"  // ToDo: JS2011 is that the right name?
double usr_parameter(int bonds, double alpha)
{
    /* add your model specifique parameter here! H=sum_i u(i,alpha)*H_i */
  //  d1 * H1 + d2 * H2 + d3 * H3 + ...
  if (bonds==1) return alpha;
  return 1.0;
}

#define UseAlpha 1
//#define StartAlpha    (-1.0*M_PI) // JS2011: non convergent start angle ???
#define StartAlpha    (0.0*M_PI) // JS2011: better start with convergence!?
// start=M_PI gives for alpha=0 m.n=6 +0.44002442 == (-Eg(LC6.6)) wrong
#define StepAlpha     (0.1*M_PI)         /* initial step of alpha, 0.001*M_PI */
#define StopAlpha     (1.0*M_PI) /* for SearchAlphaMin=1 only*/
//#define StopAlpha     (2.0*M_PI) /* for SearchAlphaMin=1 only*/
#define SearchAlphaMin 1 /* 0=startAlpha_only or 1=fix_steps, 2=dynamic_search */

double usr_angle(int bond, int term13, double *alpha, int numalpha)
{

  double mult = 0.0;  // default for other terms
  double phi  = M_PI+alpha[0];
  
  if (bond==1) { 
    // delta term
    if      (term13 ==  1) mult=       cos(phi);    // s^z s^z 
    else if (term13 ==  2) mult=  -0.5*sin(phi);    // s^z s^+ 
    else if (term13 ==  3) mult=  -0.5*sin(phi);    // s^z s^-     
  } else if (bond==2) {
    if 	    (term13 ==  4) mult=   0.5*sin(phi);    // s^+ s^z
    else if (term13 ==  5) mult=   0.5*sin(phi);    // s^- s^z
    else if (term13 ==  6) mult= 0.25*(cos(phi)+1); // s^+ s^-
    else if (term13 ==  7) mult= 0.25*(cos(phi)+1); // s^- s^+
    else if (term13 ==  8) mult= 0.25*(cos(phi)-1); // s^+ s^+
    else if (term13 ==  9) mult= 0.25*(cos(phi)-1); // s^- s^-   
  } else if (bond==3) {
      if (term13 <= 9 && term13 >= 1) mult= 1.0;
  }
  return mult;
}
